#!/bin/bash
SHOP_PATH=/opt/bukshop
UBUK_BDNAME=ubuk
REPORT_USER=db_report
GOODS_USER=goods_user
LOG0=/var/opt/bukshop/dbcron
LOCK=/var/opt/bukshop/LCK..dbcron
PID=$$

logfile=${LOG0?}.`date "+%y%m%d"`.log

#if [ -f $UBUK_BIN/ConMod.jar ]; then
    #cd $UBUK_BIN
    #java -jar ConMod.jar -c $UBUK_CONF -l $UBUK_log
#fi

cd ${SHOP_PATH?}
time=`date "+%H.%M.%S"`

if [ -f ${LOCK} ]; then
    rpid=`head -n 1 ${LOCK}`
    rcmd=`tail -n 1 ${LOCK}`
    z=`ps ax | grep "${rcmd}" | grep -v grep | grep "${rpid}" | wc -l`;
    if [ ${z} -eq 1 ] ; then
        echo  "" >> ${logfile?}  
        echo  "${time?} Процесс уже запущен... " >> ${logfile?}
        exit 0;
    fi    
fi

 
echo ${PID} > ${LOCK?}
echo $0 >> ${LOCK?} 
 

echo -n "${time?} Проверка на считывание полученых сообщений... " >> ${logfile?}
perl ${SHOP_PATH?}/cron_read_get_path.pl ${UBUK_BDNAME?}  $REPORT_USER  >> ${logfile?} 2>>${logfile?}
err=$?
if [ ${err?} -eq 0 ]; then
    echo "done." >> ${logfile?}
else
    echo "ОШИБКА ${err?}." >> ${logfile?}
fi

time=`date "+%H.%M.%S"`
echo -n "${time?} Проверки на создание команд... " >> ${logfile?}
perl ${SHOP_PATH?}/cron_msg_auto_load.pl ${UBUK_BDNAME?}  ${GOODS_USER?} >> ${logfile?} 2>>${logfile?}
err=$?
if [ ${err?} -eq 0 ]; then
    echo "done." >> ${logfile?}
else
    echo "ОШИБКА ${err?}." >> ${logfile?}
fi

#от admingoods: выполняется, если есть start.admgd.sh (установлен из пакета)
if [ -f ${SHOP_PATH?}/admgoods ]; then
    time=`date "+%H.%M.%S"`
    echo -n "${time?} Проверка на создание накладных по тайм-ауту... " >> ${logfile?}
    #REM: !!! psql -U ${GOODS_USER?} ... - так не проходит авторизация !!!
    psql ${UBUK_BDNAME?} -c "SELECT gf_do_act_line_create()" > /dev/null 2>>${logfile?}
    err=$?
    if [ ${err?} -eq 0 ]; then
        echo "done." >> ${logfile?}
    else
        echo "ОШИБКА ${err?}." >> ${logfile?}
    fi
fi

rm -f ${LOCK}
