#!/usr/bin/perl

use strict;
use warnings;

use XML::Parser;
use DBI;
use Encode;

my $local_name="localhost";
my $local_port= 5432;
my $local_dbname='ubuk';
my $local_user='db_report';
my $local_pass='db_report';

my $file = $ARGV[0];
my $tmpfile = "/tmp/article.txt";

my $dbh=undef;
my $sth = undef;

my $inpay = 0;

&main();

sub main {
  return 0 if (!(-f $file));

  $dbh = DBI->connect("dbi:Pg:dbname=$local_dbname;host=$local_name;port=$local_port",$local_user,$local_pass, { AutoCommit=>0}) or return undef;

  `iconv -f cp866 -t utf-8 $file > $tmpfile`;
  
  open FILE, $tmpfile or return 0;
  while (my $line = <FILE>) {
    if (length($line)>30){
      my $art = undef;
      my $barcode = undef;
      my $group = undef;
      my $name = undef;

      $art = trim(substr(trim($line),0,index(trim($line),' ')));  # артикул
      $line = trim(substr(trim($line),index(trim($line),' ')));
      
      my $tmppar = undef;
      
      $tmppar = trim(substr(trim($line),0,index(trim($line),' ')));
      $line = trim(substr(trim($line),index(trim($line),' ')));
      
      if (index($tmppar,'.')==-1){
        $barcode = $tmppar;   # штрих-код
        $group = trim(substr(trim($line),0,index(trim($line),' ')));  #группа
        $name = trim(substr(trim($line),index(trim($line),' ')));  # наименование
      }else{
        $barcode = '';
        $group = $tmppar;
        $name = $line;
      }
      
      $name =~ s/'//g;
      my $sqlm = "select gf_do_list_add('$art','$name','','$group',false,ARRAY[''],'',true);";
      print "$sqlm\n";
      $dbh->do($sqlm) or return 0;
      
      if (length($barcode)>1){
        my $sql="SELECT id,id_list FROM gd_identification WHERE id=lpad('$barcode',13,'0') LIMIT 1";
        print "$sql\n";
        
        $sth = $dbh->prepare($sql);
        if (!$sth || $DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef;}
        $sth->execute();
        if ($DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef; }
        
        my $tester = undef;
        while (my ($f1,$f2) = $sth->fetchrow_array) { $tester = $f2; }

        if (defined $tester){
          if ($tester ne $art) {
            my $sq1 = "select gf_do_bar_del('$tester','$barcode','true');";
            print "$sq1\n";
            $dbh->do($sq1) or return 0;
            my $sq2 = "select gf_do_bar_add('$art','$barcode','true');";
            print "$sq2\n";
            $dbh->do($sq2) or return 0;
          }
        }else{
          my $sq2 = "select gf_do_bar_add('$art','$barcode','true');";
          print "$sq2\n";
          $dbh->do($sq2) or return 0;
        }
      }
    }else{
      my $art = undef;
      my $barcode = undef;
      
      $art = trim(substr(trim($line),0,index(trim($line),' ')));  # артикул
      $barcode = trim(substr(trim($line),index(trim($line),' ')));
      
      if (length($barcode)>1){
        my $sql="SELECT id,id_list FROM gd_identification WHERE id=lpad('$barcode',13,'0') LIMIT 1";
        print "$sql\n";
        
        $sth = $dbh->prepare($sql);
        if (!$sth || $DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef;}
        $sth->execute();
        if ($DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef; }
        
        my $tester = undef;
        while (my ($f1,$f2) = $sth->fetchrow_array) { $tester = $f2; }

        if (defined $tester){
          if ($tester ne $art) {
            my $sq1 = "select gf_do_bar_del('$tester','$barcode','true');";
            print "$sq1\n";
            $dbh->do($sq1) or return 0;
            my $sq2 = "select gf_do_bar_add('$art','$barcode','true');";
            print "$sq1\n";
            $dbh->do($sq1) or return 0;
          }
        }else{
          my $sq2 = "select gf_do_bar_add('$art','$barcode','true');";
          print "$sq2\n";
          $dbh->do($sq2) or return 0;
        }
      }
    }
  }
  close FILE;      
  $dbh->commit();
  `rm $tmpfile`;

}

sub trim {
  my($string)=@_;
  return '' if (!defined $string);
  for ($string) {
    s/^\s+//;
    s/\s+$//;
  }
  return $string;
}

__END__
