#!/usr/bin/perl

use strict;
use warnings;

use DBI;
use Encode qw(from_to);

my $local_name="localhost";
my $local_port= 5432;
my $local_dbname='ubuk';
my $local_user='db_report';
my $local_pass='db_report';

my $file = $ARGV[0];
my $dbh=undef;
my $sth = undef;

my $sql;

&main();

sub main {
  return 0 if (!(-f $file));

  open (F, $file) or die "can not open file: $!";
  binmode(F);

  $dbh = DBI->connect("dbi:Pg:dbname=$local_dbname;host=$local_name;port=$local_port",$local_user,$local_pass, { AutoCommit=>0}) or return undef;
 
  $sql="SELECT * FROM gf_do_act_del_all('999')";
  #print $sql."\n";
  $dbh->do($sql) or return 0;

  my ($buf, $data, $n);
  while (($n = read F, $data, 16) != 0){
    my $hex = unpack 'h*', $data;
    my $start=0;
    my @mas = undef;
    while ($start<16){
      $mas[$start]=substr($hex,$start*2+1,1).substr($hex,$start*2,1);
      $start++;
    }

    if (hex($mas[0])==0x0F  && (hex($mas[1])==0x00 || hex($mas[1])==0x40)){
      my $art = sprintf("%d%09d", (hex($mas[6])+256 * hex($mas[7])), (hex($mas[2])+256 * hex($mas[3])+256 * 256 * hex($mas[4])+256 * 256 * 256 *  hex($mas[5])));
    
      my $price = (hex($mas[10])+256 * hex($mas[11])+256 * 256 * hex($mas[12]));
      my $count = (hex($mas[13])+256 * hex($mas[14])+256 * 256 * hex($mas[15]));
      
      $sql = "SELECT id FROM gd_list where id=$art";
      $sth = $dbh->prepare($sql);
      if (!$sth || $DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef;}
      $sth->execute();
      if ($DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef; }
        
      my $tester = undef;
      while (my ($f1) = $sth->fetchrow_array) { $tester = $f1; }
      
      print "Артикул $art не найден\n" if (!(defined $tester) && $count!=0 && $price>0);
      next if !(defined $tester);
      
      print "У артикула $art не задана цена\n" if ($price<=0 && $count>0);
      next if ($price<=0 && $count>0);
      
      next if ($count==0);
      next if ($price==0);
      
      $sql="SELECT * FROM gf_do_act_add('$art','999')";
      #print $sql."\n";
      $dbh->do($sql);
      
      $sql="SELECT * FROM gf_mod_count('$art','$count','999')";
      #print $sql."\n";
      $dbh->do($sql);
      
      $sql="SELECT * FROM gf_mod_newprice('$art',$price/100::numeric,'999')";
      #print $sql."\n";
      $dbh->do($sql);
    }
  }
  close(F);
  
  $sql="SELECT * FROM gf_do_act_create(999,ARRAY[sf_get_cur_id_shop()::integer],1,'',now()::date,'18','0','0',NULL)";
  #print $sql."\n";
  $dbh->do($sql) or return 0;
  
  $dbh->commit();

  return;
}

sub trim {
  my($string)=@_;
  return '' if (!defined $string);
  for ($string) {
    s/^\s+//;
    s/\s+$//;
  }
  return $string;
}

__END__
