#!/usr/bin/perl

use strict;
use warnings;

use Encode qw(from_to);

my $file = $ARGV[0];

&main();

sub main {
  return 0 if (!(-f $file));

  `rm artcount.txt` if (-f "artcount.txt");
  
  open (F, $file) or die "can not open file: $!";
  binmode(F);

  my ($buf, $data, $n);
  while (($n = read F, $data, 16) != 0){
    my $hex = unpack 'h*', $data;
    my $start=0;
    my @mas = undef;
    while ($start<16){
      $mas[$start]=substr($hex,$start*2+1,1).substr($hex,$start*2,1);
      $start++;
    }

    if (hex($mas[0])==0x0F  && (hex($mas[1])==0x00 || hex($mas[1])==0x40)){
      my $art = sprintf("%d%09d", (hex($mas[6])+256 * hex($mas[7])), (hex($mas[2])+256 * hex($mas[3])+256 * 256 * hex($mas[4])+256 * 256 * 256 *  hex($mas[5])));
    
      my $price = (hex($mas[10])+256 * hex($mas[11])+256 * 256 * hex($mas[12]));
      my $count = (hex($mas[13])+256 * hex($mas[14])+256 * 256 * hex($mas[15]));
      
      next if ($count==0);
      next if ($price==0);
      
      `echo "$art;$count;$price;">> artcount.txt`;    
    }
  }
  close(F);
  
  return;
}

__END__
