#!/usr/bin/perl

use strict;
use warnings;

use XML::Parser;
use DBI;
use Encode;

my $local_name="localhost";
my $local_port= 5432;
my $local_dbname='ubuk';
my $local_user='db_report';
my $local_pass='db_report';

my $file = $ARGV[0];
my $tmpfile = "/tmp/article.txt";
my $tmpfile22 = "/tmp/article2.txt";
my $tmpfile23 = "/tmp/article23.txt";
my $tmpfile2 = "/tmp/artcount.txt";

my $file2 = (defined $ARGV[1])? $ARGV[1]:undef;
my $exec = ($ARGV[2] eq "change")? "change" : "";

my $dbh=undef;
my $sth = undef;

my $inpay = 0;

&main();

sub main {
  return 0 if (!(-f $file));
  `rm logcompare.txt` if (-f "logcompare.txt");
  
  $dbh = DBI->connect("dbi:Pg:dbname=$local_dbname;host=$local_name;port=$local_port",$local_user,$local_pass, { AutoCommit=>0}) or return undef;

  `iconv -f cp866 -t utf-8 $file > $tmpfile`;
  `iconv -f cp866 -t utf-8 $file > $tmpfile23`;
  
  `cp $file2 $tmpfile2` if ($exec eq "change");

  open FILE, $tmpfile or return 0;
  while (my $line = <FILE>) {
    if (length($line)>30){
      my $art = undef;
      my $barcode = undef;
      my $group = undef;
      my $name = undef;

      $art = trim(substr(trim($line),0,index(trim($line),' ')));  # артикул
      $line = trim(substr(trim($line),index(trim($line),' ')));
      
      my $tmppar = undef;
      
      $tmppar = trim(substr(trim($line),0,index(trim($line),' ')));
      $line = trim(substr(trim($line),index(trim($line),' ')));
      
      if (index($tmppar,'.')==-1){
        $barcode = $tmppar;   # штрих-код
        $group = trim(substr(trim($line),0,index(trim($line),' ')));  #группа
        $name = trim(substr(trim($line),index(trim($line),' ')));  # наименование
      }else{
        $barcode = '';
        $group = $tmppar;
        $name = $line;
      }
      
      $name =~ s/'//g;
      
      if (length($barcode)>1){
        my $sql="SELECT $art, id_list, id FROM gd_identification WHERE id=lpad('$barcode',13,'0') LIMIT 1";
        #print "$sql\n";
        
        $sth = $dbh->prepare($sql);
        if (!$sth || $DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef;}
        $sth->execute();
        if ($DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef; }
        
        my $tester = undef;
        while (my ($f1,$f2, $f3) = $sth->fetchrow_array) { 
          next if($f1 == $f2);
          if (defined $file2){
            open FILE2, $file2 or return 0;
            while (my $line2 = <FILE2>) {
              my $art2 = trim(substr(trim($line2),0,index(trim($line2),';')));
              if ($art2 == $f1){
                `echo "На старой АЗС артикул $f1, в новом справочнике $f2. Штрих-код: $f3" >> logcompare.txt` if ($f1 != $f2);
                print "На старой АЗС артикул $f1, в новом справочнике $f2. Штрих-код: $f3\n" if ($f1 != $f2);
                `perl -e 's/^$art2;/$f2;/g' -pi $tmpfile2` if ($exec eq "change");
                
                `cat $tmpfile23 | sed '/^[ ]*$f1/d' > $tmpfile22` if ($exec eq "change");
                `cp $tmpfile22 $tmpfile23` if ($exec eq "change");
              }
            }
            close FILE2;   
          }else{
            `echo "На старой АЗС артикул $f1, в новом справочнике $f2. Штрих-код: $f3" >> logcompare.txt` if ($f1 != $f2);
            print "На старой АЗС артикул $f1, в новом справочнике $f2. Штрих-код: $f3\n" if ($f1 != $f2);
          }
        }
      }
    }else{
      my $art = undef;
      my $barcode = undef;
      
      $art = trim(substr(trim($line),0,index(trim($line),' ')));  # артикул
      $barcode = trim(substr(trim($line),index(trim($line),' ')));
      
      if (length($barcode)>1){
        my $sql="SELECT $art, id_list, id FROM gd_identification WHERE id=lpad('$barcode',13,'0') LIMIT 1";
        #print "$sql\n";
        
        $sth = $dbh->prepare($sql);
        if (!$sth || $DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef;}
        $sth->execute();
        if ($DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef; }
        
        my $tester = undef;
        while (my ($f1,$f2, $f3) = $sth->fetchrow_array) { 
          next if($f1 == $f2);
          if (defined $file2){
            open FILE2, $file2 or return 0;
            while (my $line2 = <FILE2>) {
              my $art2 = trim(substr(trim($line2),0,index(trim($line2),';')));
              if ($art2 == $f1){
                `echo "На старой АЗС артикул $f1, в новом справочнике $f2. Штрих-код: $f3" >> logcompare.txt` if ($f1 != $f2);
                print "На старой АЗС артикул $f1, в новом справочнике $f2. Штрих-код: $f3\n" if ($f1 != $f2);
                
                `perl -e 's/^$art2;/$f2;/g' -pi $tmpfile2` if ($exec eq "change");
                `cat $tmpfile23 | sed '/^[ ]*$f1/d' > $tmpfile22` if ($exec eq "change");
                `cp $tmpfile22 $tmpfile23` if ($exec eq "change");
              }
            }
            close FILE2;   
          }else{
            `echo "На старой АЗС артикул $f1, в новом справочнике $f2. Штрих-код: $f3" >> logcompare.txt` if ($f1 != $f2);
            print "На старой АЗС артикул $f1, в новом справочнике $f2. Штрих-код: $f3\n" if ($f1 != $f2);
          }
        }
      }
    }
  }
  close FILE;   
  `rm $tmpfile`;
  `mv $tmpfile2 $file2` if ($exec eq "change");
  `iconv -f utf-8 -t cp866 $tmpfile23 > $file` if ($exec eq "change");
}

sub trim {
  my($string)=@_;
  return '' if (!defined $string);
  for ($string) {
    s/^\s+//;
    s/\s+$//;
  }
  return $string;
}

__END__
