#!/usr/bin/perl

use strict;
use warnings;

use DBI;
use Encode qw(from_to);

my $local_name="localhost";
my $local_port= 5432;
my $local_dbname='ubuk';
my $local_user='db_report';
my $local_pass='db_report';

my $file = $ARGV[0];
my $exec = ($ARGV[1] eq "exec")? "exec" : "";
my $dbh=undef;
my $sth = undef;

my $sql;

&main();

sub main {
  return 0 if (!(-f $file));

  open (F, $file) or die "can not open file: $!";
  binmode(F);

  $dbh = DBI->connect("dbi:Pg:dbname=$local_dbname;host=$local_name;port=$local_port",$local_user,$local_pass, { AutoCommit=>0}) or return undef;
 
  $sql="SELECT * FROM gf_do_act_del_all('999')";
  #print $sql."\n";
  $dbh->do($sql) or return 0;

  open FILE, $file or return 0;
  while (my $line = <FILE>) {
    my $art = trim(substr(trim($line),0,index(trim($line),';')));  # артикул
    $line = trim(substr(trim($line),index(trim($line),';')+1));  # артикул
    my $count = trim(substr(trim($line),0,index(trim($line),';')));  # количество
    $line = trim(substr(trim($line),index(trim($line),';')+1));  # артикул
    my $price = trim(substr(trim($line),0,index(trim($line),';')));  # цена в копейках
      
    $sql = "SELECT id, a.id_list FROM gd_list LEFT JOIN (SELECT id_list FROM gd_actions_adm WHERE id_desk=999) as a ON (a.id_list=gd_list.id) where id=$art";
    $sth = $dbh->prepare($sql);
    if (!$sth || $DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef;}
    $sth->execute();
    if ($DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef; }
        
    my $tester = undef;
    my $tester2 = undef;
    while (my ($f1, $f2) = $sth->fetchrow_array) { $tester = $f1; $tester2 = $f2; }
      
    print "Артикул $art не найден\n" if (!(defined $tester) && $count!=0 && $price>0);
    next if !(defined $tester);
      
    print "У артикула $art не задана цена\n" if ($price<=0 && $count>0);
    next if ($price<=0 && $count>0);
      
    next if ($count eq "0");
    next if ($price eq "0");
      
    if (defined $tester2){
      $sql="UPDATE gd_actions_adm SET count=count+$count WHERE id_list=$art AND id_desk=999";
      #print $sql."\n";
      $dbh->do($sql);
    }else{
      $sql="SELECT * FROM gf_do_act_add('$art','999')";
      #print $sql."\n";
      $dbh->do($sql);
      
      $sql="SELECT * FROM gf_mod_count('$art','$count','999')";
      #print $sql."\n";
      $dbh->do($sql);
      
      $sql="SELECT * FROM gf_mod_newprice('$art',$price/100::numeric,'999')";
      #print $sql."\n";
      $dbh->do($sql);
    }
  }
  close(F);
  
  $sql="SELECT * FROM gf_do_act_create(999,ARRAY[sf_get_cur_id_shop()::integer],1,'',now()::date,'18','0','0',NULL)";
  if ($exec eq "exec"){
    #print $sql."\n";
    $dbh->do($sql) or return 0;
  }
  
  $dbh->commit();

  return;
}

sub trim {
  my($string)=@_;
  return '' if (!defined $string);
  for ($string) {
    s/^\s+//;
    s/\s+$//;
  }
  return $string;
}

__END__
