#!/usr/bin/perl

use strict;
use warnings;

use XML::Parser;
use DBI;
use Encode;

my $local_name="localhost";
my $local_port= 5432;
my $local_dbname='ubuk';
my $local_user='db_report';
my $local_pass='db_report';

my $file = $ARGV[0];
my $tmpfile = "/tmp/artgroup.txt";

my $dbh=undef;
my $sth = undef;

my $inpay = 0;

&main();

sub main {
  return 0 if (!(-f $file));

  $dbh = DBI->connect("dbi:Pg:dbname=$local_dbname;host=$local_name;port=$local_port",$local_user,$local_pass, { AutoCommit=>0}) or return undef;

  `iconv -f cp866 -t utf-8 $file > $tmpfile`;
  
  open FILE, $tmpfile or return 0;
  while (my $line = <FILE>) {
    my $path=trim(substr(trim($line),0,index(trim($line),' ')));
    my $title=trim(substr(trim($line),index(trim($line),' ')));
  
    next if (length($title)==0);
    next if (length($path)==0);

    #$title = substr($title,0,40) if length($title)>40;
    my $pathpar = substr($path,0, length($path)-1);
    while ((length($pathpar)!=0) && (substr($pathpar, length($pathpar)-1) ne ".")){
      $pathpar=substr($pathpar,0, length($pathpar)-1);
    }
    
    my $sql="SELECT gd_group_list.id,gd_group_list.title,gd_group_list.extra_change,gd_tax.rate 
             FROM gd_group_list,gd_tax 
             WHERE gd_tax.id=gd_group_list.id_tax AND gf_get_grp_path(gd_group_list.id)='$path' LIMIT 1";

    $sth = $dbh->prepare($sql);
    if (!$sth || $DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef;}
    $sth->execute();
    if ($DBI::err) { $sth->finish if (defined $sth); $sth = undef; return undef; }
    
    my $readid=undef;
    my $readtitle=undef;
    my $readextra=undef;
    my $readtax=undef;
    
    while (my ($f1,$f2, $f3, $f4) = $sth->fetchrow_array) {
      $readid=$f1;
      $readtitle=$f2;
      $readextra=$f3;
      $readtax=$f4;
    }

    if (defined $readid){
      if ($readtitle ne $title){
        my $sqlm = "select gf_do_grp_change('$path','$pathpar','$title','$readextra','$readtax','true');";
        print "$sqlm\n";
        $dbh->do($sqlm) or return 0;
      }
    } else{
      my $sqlm = "select gf_do_grp_add('$pathpar','$title','0','18','true');";
      print "$sqlm\n";
      $dbh->do($sqlm) or return 0;
    }
  }
  close FILE;      
  $dbh->commit();
  `rm $tmpfile`;

}

sub trim {
  my($string)=@_;
  return '' if (!defined $string);
  for ($string) {
    s/^\s+//;
    s/\s+$//;
  }
  return $string;
}

__END__
